/**
 * lines draw demo
 */
import waba.fx.*;
import waba.ui.*;

public class MainClass extends MainWindow {
  private final int FLOW_LINE_NMB = 10;

  private FlowLine[] fl = new FlowLine[FLOW_LINE_NMB];
  private int flIdx;

  private int x1, y1, x2, y2;
  private int mx1, my1, mx2, my2;

  public void onStart() {
    flIdx = 0;
    x1 = Rnd.nextInt()&(63*256); y1 = Rnd.nextInt()&(63*256);
    x2 = Rnd.nextInt()&(63*256); y2 = Rnd.nextInt()&(63*256);
    mx1 = Rnd.nextInt()%768; my1 = Rnd.nextInt()%768;
    mx2 = Rnd.nextInt()%768; my2 = Rnd.nextInt()%768;
  }

  private final int WIDTH = 102*256, HEIGHT = 64*256;

  public void onPaint(Graphics g) {
    for ( int i=0 ; i<32 ; i++ ) {
      if ( fl[flIdx] != null ) {
        fl[flIdx].clear(g);
      } else {
        fl[flIdx] = new FlowLine();
      }
      fl[flIdx].setPos(x1/256, y1/256, x2/256, y2/256);
      fl[flIdx].draw(g);
      x1 += mx1; y1 += my1;
      if ( x1 < 0 || x1 >= WIDTH ) {
        mx1 = -mx1; x1 += mx1*2;
      }
      if ( y1 < 0 || y1 >= HEIGHT ) {
        my1 = -my1; y1 += my1*2;
      }
      x2 += mx2; y2 += my2;
      if ( x2 < 0 || x2 >= WIDTH ) {
        mx2 = -mx2; x2 += mx2*2;
      }
      if ( y2 < 0 || y2 >= HEIGHT ) {
        my2 = -my2; y2 += my2*2;
      }
      flIdx++; if ( flIdx >= FLOW_LINE_NMB ) flIdx = 0;
    }
  }
}
